diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAlgae.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAlgae.java
index 4f02470ae..f486b5089 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAlgae.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAlgae.java
@@ -10,15 +10,17 @@ import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
@@ -32,7 +34,7 @@ public class BlockLogicAlgae
     }
 
     @Override
-    public void onEntityCollision(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Entity entity) {
+    public void onEntityCollision(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Entity entity) {
         if (entity instanceof EntityBoat) {
             world.playBlockEvent(null, tilePos, LevelListener.EVENT_BLOCK_BREAK, this.block.id());
             world.setBlockIdNotify(tilePos, 0);
@@ -40,20 +42,20 @@ public class BlockLogicAlgae
     }
 
     @Override
-    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePosc tilePos) {
         final int blockId = world.getBlockId(tilePos);
-        return blockId == 0 && Blocks.hasTag(world.getBlockId(tilePos.down()), BlockTags.IS_WATER) && world.getBlockData(tilePos.down()) == 0;
+        return blockId == 0 && Blocks.hasTag(world.getBlockId(tilePos.add(Direction.DOWN, new TilePos())), BlockTags.IS_WATER) && world.getBlockData(tilePos.add(Direction.DOWN, new TilePos())) == 0;
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePos tilePos, final int id) {
-        if (!Blocks.hasTag(world.getBlockId(tilePos.down()), BlockTags.IS_WATER) || world.getBlockData(tilePos.down()) != 0) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
+        if (!Blocks.hasTag(world.getBlockId(tilePos.add(Direction.DOWN, new TilePos())), BlockTags.IS_WATER) || world.getBlockData(tilePos.add(Direction.DOWN, new TilePos())) != 0) {
             world.setBlockId(tilePos, 0);
         }
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return null;
     }
 
@@ -68,47 +70,50 @@ public class BlockLogicAlgae
     }
 
     @Override
-    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
     @Override
     public @NotNull ItemStack @Nullable [] getBreakResult(final @NotNull World world, final @NotNull EnumDropCause dropCause, final int data, final @Nullable TileEntity tileEntity) {
         return switch (dropCause) {
-            case SILK_TOUCH, PICK_BLOCK -> new ItemStack[] { new ItemStack(this.block) };
+            case SILK_TOUCH, PICK_BLOCK -> new ItemStack[]{new ItemStack(this.block)};
             default -> null;
         };
     }
 
     @Override
-    public boolean onBonemealUsed(final @NotNull ItemStack itemStack, final @Nullable Player player, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+    public boolean onBonemealUsed(final @NotNull ItemStack itemStack, final @Nullable Player player, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         final @NotNull Random rand = world.rand;
 
         if (!world.isClientSide) {
             if (player == null || player.getGamemode().consumeBlocks()) {
                 itemStack.stackSize--;
             }
-            label0:
+            TilePos queryPos = new TilePos();
+            outer:
             for (int i = 0; i < 128; i++) {
-                final @NotNull TilePos localPos = new TilePos(tilePos);
+                int checkX = tilePos.x();
+                int checkY = tilePos.y();
+                int checkZ = tilePos.z();
                 for (int j = 0; j < i / 16; j++) {
-                    localPos.x += rand.nextInt(3) - 1;
-                    localPos.z += rand.nextInt(3) - 1;
-                    final int bId = world.getBlockId(localPos.down());
-                    final int bMeta = world.getBlockData(localPos.down());
+                    checkX += rand.nextInt(3) - 1;
+                    checkZ += rand.nextInt(3) - 1;
+                    final int bId = world.getBlockId(queryPos.set(checkX, checkY - 1, checkZ));
+                    final int bMeta = world.getBlockData(queryPos.set(checkX, checkY - 1, checkZ));
                     if (bId != Blocks.FLUID_WATER_FLOWING.id() && bId != Blocks.FLUID_WATER_STILL.id()) {
-                        continue label0;
+                        continue outer;
                     }
                     if (bMeta != 0) {
-                        continue label0;
+                        continue outer;
                     }
                 }
 
-                if (world.getBlockId(localPos) != 0) {
+                if (world.getBlockId(queryPos.set(checkX, checkY, checkZ)) != 0) {
                     continue;
                 }
                 if (rand.nextFloat() > 0.75) {
-                    world.setBlockIdNotify(localPos, this.block.id());
+                    world.setBlockIdNotify(queryPos.set(checkX, checkY, checkZ), this.block.id());
                 }
             }
             return true;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAsh.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAsh.java
index c60741c04..8db54e008 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAsh.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAsh.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
@@ -12,7 +12,7 @@ public class BlockLogicAsh
     extends BlockLogic {
 
     public BlockLogicAsh(final @NotNull Block<?> block) {
-        super(block, Material.ash);
+        super(block, Materials.ASH);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAxisAligned.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAxisAligned.java
index e557431c6..5305375e2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAxisAligned.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAxisAligned.java
@@ -6,7 +6,7 @@ import net.minecraft.core.enums.PlacementMode;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicAxisAligned
@@ -18,14 +18,14 @@ public class BlockLogicAxisAligned
     }
 
     @Override
-    public void onPlacedByMob(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
+    public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
         final @NotNull Axis axis = mob.getPlacementDirection(side, PlacementMode.SIDE).getAxis();
 
         world.setBlockDataNotify(tilePos, axisToMeta(axis));
     }
 
     @Override
-    public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+    public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         final @NotNull Axis axis = side.getAxis();
 
         world.setBlockDataNotify(tilePos, axisToMeta(axis));
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
index 701d1cfb7..62c083fdc 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
@@ -17,6 +17,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -29,7 +30,7 @@ public class BlockLogicBasket extends BlockLogic {
     }
 
     @Override
-    public boolean onInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
+    public boolean onInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
         final @NotNull TileEntityBasket tileEntity = (TileEntityBasket) Objects.requireNonNull(world.getTileEntity(tilePos));
 
         if (tileEntity.getNumUnitsInside() > 0) {
@@ -42,11 +43,11 @@ public class BlockLogicBasket extends BlockLogic {
     }
 
     @Override
-    public void onActivatorInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull TileEntityActivator activator, final @NotNull Direction direction) {
+    public void onActivatorInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull TileEntityActivator activator, final @NotNull Direction direction) {
         final @NotNull TileEntityBasket tileEntity = (TileEntityBasket) Objects.requireNonNull(world.getTileEntity(tilePos));
 
         if (tileEntity.getNumUnitsInside() > 0) {
-            tileEntity.dropContents(world, tilePos.x, tilePos.y, tilePos.z);
+            tileEntity.dropContents(world, tilePos.x(), tilePos.y(), tilePos.z());
         }
     }
 
@@ -56,7 +57,7 @@ public class BlockLogicBasket extends BlockLogic {
     }
 
     @Override
-    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         if (side == Side.TOP) {
             return PartialSupport.INSTANCE;
         } else {
@@ -64,7 +65,7 @@ public class BlockLogicBasket extends BlockLogic {
         }
     }
 
-    public int getFillLevel(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public int getFillLevel(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         final @NotNull TileEntityBasket tileEntity = (TileEntityBasket) Objects.requireNonNull(source.getTileEntity(tilePos));
 
         final float fill = MathHelper.clamp(tileEntity.getNumUnitsInside() / (float) tileEntity.getMaxUnits(), 0, 1); // Clamps the visual effect even if the basket gets overstuffed
@@ -89,27 +90,29 @@ public class BlockLogicBasket extends BlockLogic {
     }
 
     @Override
-    public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePos tilePos) {
-        for (final @NotNull Side s : Side.sides) {
-            world.notifyBlocksOfNeighborChange(tilePos.add(s.getDirection()), this.id());
+    public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
+        for (final @NotNull Direction d : Direction.directions) {
+            world.notifyBlocksOfNeighborChange(tilePos.add(d, queryPos), this.id());
         }
     }
 
     @Override
-    public void onRemoved(final @NotNull World world, final @NotNull TilePos tilePos, final int data) {
-        for (final @NotNull Side s : Side.sides) {
-            world.notifyBlocksOfNeighborChange(tilePos.add(s.getDirection()), this.id());
+    public void onRemoved(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
+        TilePos queryPos = new TilePos();
+        for (final @NotNull Direction d : Direction.directions) {
+            world.notifyBlocksOfNeighborChange(tilePos.add(d, queryPos), this.id());
         }
     }
 
     @Override
-    public boolean isEmittingSignal(final @NotNull WorldSource source, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public boolean isEmittingSignal(final @NotNull WorldSource source, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         final @NotNull TileEntityBasket tileEntity = (TileEntityBasket) Objects.requireNonNull(source.getTileEntity(tilePos));
         return tileEntity.getNumUnitsInside() >= tileEntity.getMaxUnits();
     }
 
     @Override
-    public boolean isEmittingDirectSignal(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public boolean isEmittingDirectSignal(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return this.isEmittingSignal(world, tilePos, side);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
index 26810fb9b..9fd2d1fb9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
@@ -3,6 +3,7 @@ package net.minecraft.core.block;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
@@ -12,8 +13,8 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -23,26 +24,26 @@ public class BlockLogicBed
     extends BlockLogic {
 
     public BlockLogicBed(final @NotNull Block<?> block) {
-        super(block, Material.wood);
+        super(block, Materials.WOOD);
         this.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.5625F, 1.0F);
     }
 
     @Override
-    public boolean onInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
+    public boolean onInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
         if (world.isClientSide) {
             return true;
         }
 
         int data = world.getBlockData(tilePos);
-        final @NotNull TilePos headPos;
-        final @NotNull TilePos footPos;
+        final @NotNull TilePosc headPos;
+        final @NotNull TilePosc footPos;
         if (!isBlockFootOfBed(data)) {
             final int dir = getDirection(data);
             headPos = tilePos;
-            footPos = tilePos.add(headBlockToFootBlockMap[dir].getDirection());
+            footPos = tilePos.add(headBlockToFootBlockMap[dir].getDirection(), new TilePos());
         } else {
             final int dir = getDirection(data);
-            headPos = tilePos.sub(headBlockToFootBlockMap[dir].getDirection());
+            headPos = tilePos.sub(headBlockToFootBlockMap[dir].getDirection(), new TilePos());
             footPos = tilePos;
         }
 
@@ -61,7 +62,7 @@ public class BlockLogicBed
                 world.setBlockIdNotify(footPos, 0);
             }
             player.addStat(Achievements.SLEEP_NETHER, 1);
-            world.createExplosion(null, tilePos.x + 0.5F, tilePos.y + 0.5F, tilePos.z + 0.5F, 5F, true, false);
+            world.createExplosion(null, tilePos.x() + 0.5F, tilePos.y() + 0.5F, tilePos.z() + 0.5F, 5F, true, false);
             return true;
         }
 
@@ -85,7 +86,7 @@ public class BlockLogicBed
         }
 
         // Sleep
-        if (player.sleepInBedAt(footPos.x, footPos.y, footPos.z) == EnumSleepStatus.OK) {
+        if (player.sleepInBedAt(footPos.x(), footPos.y(), footPos.z()) == EnumSleepStatus.OK) {
             setBedOccupied(world, footPos, true);
             return true;
         }
@@ -104,39 +105,39 @@ public class BlockLogicBed
     }
 
     @Override
-    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePos tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
         this.removeOtherHalf(world, tilePos);
     }
 
     @Override
-    public void onRemoved(final @NotNull World world, final @NotNull TilePos tilePos, final int data) {
+    public void onRemoved(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
         this.removeOtherHalf(world, tilePos);
     }
 
-    protected void removeOtherHalf(final @NotNull World world, final @NotNull TilePos tilePos) {
+    protected void removeOtherHalf(final @NotNull World world, final @NotNull TilePosc tilePos) {
         final int data = world.getBlockData(tilePos);
         final int direction = getDirection(data);
         if (isBlockFootOfBed(data)) {
-            if (world.getBlockId(tilePos.sub(headBlockToFootBlockMap[direction].getDirection())) != this.block.id()) {
+            if (world.getBlockId(tilePos.sub(headBlockToFootBlockMap[direction].getDirection(), new TilePos())) != this.block.id()) {
                 world.setBlockIdNotify(tilePos, 0);
             }
-        } else if (world.getBlockId(tilePos.add(headBlockToFootBlockMap[direction].getDirection())) != this.block.id()) {
+        } else if (world.getBlockId(tilePos.add(headBlockToFootBlockMap[direction].getDirection(), new TilePos())) != this.block.id()) {
             world.setBlockIdNotify(tilePos, 0);
         }
     }
 
     @Override
     public ItemStack[] getBreakResult(@NotNull final World world, @NotNull final EnumDropCause dropCause, final int data, final @Nullable TileEntity tileEntity) {
-        return new ItemStack[] { new ItemStack(Items.BED) };
+        return new ItemStack[]{new ItemStack(Items.BED)};
     }
 
     @Override
-    public int getPistonPushReaction(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public int getPistonPushReaction(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return Material.PISTON_DESTROY_ON_PUSH;
     }
 
@@ -156,7 +157,7 @@ public class BlockLogicBed
         return meta & MASK_DIRECTION;
     }
 
-    public static void setBedOccupied(final @NotNull World world, final @NotNull TilePos tilePos, final boolean flag) {
+    public static void setBedOccupied(final @NotNull World world, final @NotNull TilePosc tilePos, final boolean flag) {
         int l = world.getBlockData(tilePos);
         if (flag) {
             l |= MASK_IS_OCCUPIED;
@@ -176,18 +177,21 @@ public class BlockLogicBed
                 tilePos.y,
                 tilePos.z - headBlockToFootBlockMap[direction].getOffsetZ() * d - 1
             );
-            final @NotNull TilePos maxPos = minPos.add(2, 0, 2);
-            final @NotNull TilePos pos = new TilePos(minPos);
-            for (pos.x = minPos.x; pos.x <= maxPos.x; pos.x++) {
-                for (pos.z = minPos.z; pos.z <= maxPos.z; pos.z++) {
-                    if (!world.isBlockNormalCube(pos.down()) || !world.isAirBlock(pos) || !world.isAirBlock(pos.up())) {
+            final @NotNull TilePos maxPos = minPos.add(2, 0, 2, new TilePos());
+
+            final @NotNull TilePos queryPos = new TilePos();
+            for (int x = minPos.x; x <= maxPos.x; x++) {
+                for (int z = minPos.z; z <= maxPos.z; z++) {
+                    if (!world.isBlockNormalCube(queryPos.set(x, minPos.y - 1, z)) ||
+                        !world.isAirBlock(queryPos.set(x, minPos.y, z)) ||
+                        !world.isAirBlock(queryPos.set(x, minPos.y + 1, z))) {
                         continue;
                     }
 
                     if (attempts > 0) {
                         attempts--;
                     } else {
-                        return pos;
+                        return queryPos.set(x, minPos.y, z);
                     }
                 }
 
@@ -217,10 +221,10 @@ public class BlockLogicBed
     };
 
     public static final @NotNull Side @NotNull [] headBlockToFootBlockMap =
-    {
-        Side.SOUTH,
-        Side.WEST,
-        Side.NORTH,
-        Side.EAST
-    };
+        {
+            Side.SOUTH,
+            Side.WEST,
+            Side.NORTH,
+            Side.EAST
+        };
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBedrock.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBedrock.java
index a084d321f..b45fac098 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBedrock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBedrock.java
@@ -1,9 +1,11 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicBedrock
@@ -13,8 +15,8 @@ public class BlockLogicBedrock
     }
 
     @Override
-    public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePos tilePos) {
-        if (world.getBlock(tilePos.down()) == Blocks.GLOWSTONE) {
+    public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        if (world.getBlock(tilePos.add(Direction.DOWN, new TilePos())) == Blocks.GLOWSTONE) {
             Blocks.PORTAL_DRIFT.getLogic().tryToCreatePortal(world, tilePos, DyeColor.SILVER);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoneShale.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoneShale.java
index ceb0f8504..761c1bcd3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoneShale.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBoneShale.java
@@ -5,7 +5,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicBoneShale
@@ -15,7 +15,7 @@ public class BlockLogicBoneShale
     }
 
     @Override
-    public float getStrength(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final @NotNull Player player) {
+    public float getStrength(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Player player) {
         final int data = world.getBlockData(tilePos);
         final @NotNull Direction direction = BlockLogicFullyRotatable.metaToDirection(data);
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBrazier.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBrazier.java
index d71aa9d1b..277f90080 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBrazier.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBrazier.java
@@ -2,7 +2,7 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.FullSupport;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
@@ -15,6 +15,7 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -25,7 +26,7 @@ public class BlockLogicBrazier
     private final boolean burning;
 
     public BlockLogicBrazier(final @NotNull Block<?> block, final boolean burning) {
-        super(block, Material.metal);
+        super(block, Materials.METAL);
         this.burning = burning;
     }
 
@@ -44,7 +45,7 @@ public class BlockLogicBrazier
     }
 
     @Override
-    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         if (side == Side.BOTTOM) {
             return FullSupport.INSTANCE;
         } else {
@@ -58,19 +59,20 @@ public class BlockLogicBrazier
     }
 
     @Override
-    public boolean onInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
+    public boolean onInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
         final @Nullable ItemStack heldItem = player.getHeldItem();
         if (heldItem != null && heldItem.getItem() instanceof ItemFireStriker && !this.burning) {
+            TilePos queryPos = new TilePos();
             Block<?> b;
-            if ((b = world.getBlock(tilePos.east())) != null && b.getLogic() instanceof BlockLogicFluid ||
-                (b = world.getBlock(tilePos.west())) != null && b.getLogic() instanceof BlockLogicFluid ||
-                (b = world.getBlock(tilePos.south())) != null && b.getLogic() instanceof BlockLogicFluid ||
-                (b = world.getBlock(tilePos.north())) != null && b.getLogic() instanceof BlockLogicFluid) {
+            if ((b = world.getBlock(tilePos.add(Direction.EAST, queryPos))) != null && b.getLogic() instanceof BlockLogicFluid ||
+                (b = world.getBlock(tilePos.add(Direction.WEST, queryPos))) != null && b.getLogic() instanceof BlockLogicFluid ||
+                (b = world.getBlock(tilePos.add(Direction.SOUTH, queryPos))) != null && b.getLogic() instanceof BlockLogicFluid ||
+                (b = world.getBlock(tilePos.add(Direction.NORTH, queryPos))) != null && b.getLogic() instanceof BlockLogicFluid) {
                 return false;
             }
             world.setBlockIdDataNotify(tilePos, Blocks.BRAZIER_ACTIVE.id(), 0);
             heldItem.damageItem(1, player);
-            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x + 0.5D, tilePos.y + 0.5D, tilePos.z + 0.5D, "fire.ignite", 1.0F, world.rand.nextFloat() * 0.4F + 0.8F);
+            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x() + 0.5D, tilePos.y() + 0.5D, tilePos.z() + 0.5D, "fire.ignite", 1.0F, world.rand.nextFloat() * 0.4F + 0.8F);
             return true;
         }
         if (heldItem == null && this.burning) {
@@ -82,21 +84,21 @@ public class BlockLogicBrazier
     }
 
     @Override
-    public void onActivatorInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull TileEntityActivator activator, final @NotNull Direction direction) {
+    public void onActivatorInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull TileEntityActivator activator, final @NotNull Direction direction) {
         if (this.burning) {
             world.setBlockIdDataNotify(tilePos, Blocks.BRAZIER_INACTIVE.id(), 0);
         }
     }
 
     @Override
-    public void onRemoved(final @NotNull World world, final @NotNull TilePos tilePos, final int data) {
+    public void onRemoved(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
         if (this.burning) {
             Blocks.FIRE.onRemoved(world, tilePos, data);
         }
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePos tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
         if (!this.burning) return;
         final @Nullable Block<?> block = Blocks.blocksList[id];
         if (block != null && block.getLogic() instanceof BlockLogicFluid) {
@@ -105,7 +107,7 @@ public class BlockLogicBrazier
     }
 
     @Override
-    public void animationTick(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand) {
+    public void animationTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand) {
         if (this.burning) {
             Blocks.FIRE.animationTick(world, tilePos, rand);
         }
